Summary:	heartbeat subsystem for High-Availability Linux
Name:		heartbeat
Version:	1.2.0
Release:	1.5.4
License:	GPL
Group:		Utilities
Source0:	http://linux-ha.org/download/%{name}-%{version}.tar.gz
Buildroot:	%{_tmppath}/%{name}-%{release}-root
BuildPrereq:	glib-devel, perl, iputils, /usr/bin/ssh, openssl-devel, libnet
Requires:	syslog-ng, klogd, , heartbeat-stonith = %{version}-%{release}
Requires:	heartbeat-pils = %{version}-%{release}

%description
heartbeat is a basic high-availability subsystem for Linux-HA.
It will run scripts at initialization, and when machines go up or down.
This version will also perform IP address takeover using gratuitous ARPs.
It works correctly for a 2-node configuration, and is extensible to larger
configurations.

%files
  %defattr(-,root,root)
  %dir /etc/ha.d
  /etc/ha.d/harc
  /etc/ha.d/shellfuncs
  /etc/ha.d/rc.d
  /etc/ha.d/README.config
  /usr/lib/heartbeat
  /usr/lib/libhbclient.*
  /usr/lib/libccmclient.*
  /usr/lib/libplumb.*
  /usr/lib/libapphb.*
  /usr/lib/librecoverymgr.*
  /usr/lib/libckpt.*
  /usr/include/heartbeat
  /usr/include/clplumbing
  /usr/include/saf
  /usr/include/ocf
  /etc/ha.d/resource.d/
  /etc/init.d/heartbeat
  /etc/logrotate.d/heartbeat
  /var/adm/fillup-templates/rc.config.heartbeat
  %dir /var/lib/heartbeat
  %attr (600, root, root)       /var/lib/heartbeat/fifo
  %dir %attr (750, root, haclient) /var/lib/heartbeat/api
  %dir %attr (755, root, haclient) /var/lib/heartbeat/ckpt
  %attr (755, hacluster, haclient) /var/lib/heartbeat/ccm
  %attr (1770, root, haclient) /var/lib/heartbeat/casual
  %doc %{_mandir}/man8/heartbeat.8*
  %doc %{_mandir}/man8/apphbd.8*
  %doc doc/AUTHORS
  %doc doc/COPYING
  %doc doc/ChangeLog
  %doc doc/GettingStarted.html
  %doc doc/GettingStarted.txt
  %doc doc/HardwareGuide.html
  %doc doc/HardwareGuide.txt
  %doc doc/README
  %doc doc/Requirements.html
  %doc doc/Requirements.txt
  %doc doc/apphbd.cf
  %doc doc/authkeys
  %doc doc/faqntips.html
  %doc doc/faqntips.txt
  %doc doc/ha.cf
  %doc doc/haresources
  %doc doc/rsync.html
  %doc doc/rsync.txt
  %doc doc/startstop

%package ldirectord
Summary:	Monitor daemon for maintaining high availability resources
Group:		Utilities
Requires:	perl, perl-libwww-perl perl-Net-SSLeay, ipvsadm
Requires:	perl-HTML-Parser, perl-ldap, perl-Mail-IMAPClient, perl-libnet

%description ldirectord
ldirectord is a stand-alone daemon to monitor services of real 
for virtual services provided by The Linux Virtual Server
(http://www.linuxvirtualserver.org/). It is simple to install 
and works with the heartbeat code (http://www.linux-ha.org/).

%files ldirectord
  %doc ldirectord/ldirectord.cf
  %defattr(-,root,root)
  /etc/ha.d/conf
  /usr/sbin/ldirectord
  /usr/sbin/supervise-ldirectord-config
  /etc/logrotate.d/ldirectord
  /etc/init.d/ldirectord
  /etc/ha.d/resource.d/ldirectord
  %{_mandir}/man8/ldirectord.8*
  %{_mandir}/man8/supervise-ldirectord-config.8*

%package stonith
Summary:	Provides an interface to Shoot The Other Node In The Head 
Requires:	heartbeat-pils = %{version}-%{release}
Group:		Utilities

%files stonith
  %defattr(-,root,root)
  /usr/include/stonith
  /usr/lib/libstonith.*
  /usr/lib/stonith
  /usr/sbin/stonith
  /usr/sbin/meatclient
  %doc %{_mandir}/man8/stonith.8*
  %doc %{_mandir}/man8/meatclient.8*

%description stonith
The STONITH module (a.k.a. STOMITH) provides an extensible interface
for remotely powering down a node in the cluster.  The idea is quite simple:
When the software running on one machine wants to make sure another
machine in the cluster is not using a resource, pull the plug on the other 
machine. It's simple and reliable, albeit admittedly brutal.

%package pils
Summary:	Provides a general plugin and interface loading library
Group:		Utilities

%files pils
  %defattr(-,root,root)
  /usr/include/pils
  /usr/lib/libpils.*
  /usr/lib/pils/plugins

%description pils
PILS is an generalized and portable open source
Plugin and Interface Loading System.
PILS was developed as part of the Open Cluster Framework
reference implementation, and is designed
to be directly usable by a wide variety of other applications.
PILS manages both plugins (loadable objects),
and the interfaces these plugins implement.
PILS is designed to support any number of plugins
implementing any number of interfaces.

%prep
%setup -q
%build
  export CFLAGS=$RPM_OPT_FLAGS
  ./configure					\
	--host=%{_host}				\
	--build=%{_build}			\
	--target=%{_target_platform}		\
	--prefix=%{_prefix}			\
	--exec-prefix=%{_exec_prefix}		\
	--bindir=%{_bindir}			\
	--sbindir=%{_sbindir}			\
	--sysconfdir=%{_sysconfdir}		\
	--datadir=%{_datadir}			\
	--includedir=%{_includedir}		\
	--libdir=%{_libdir}			\
	--libexecdir=%{_libexecdir}		\
	--localstatedir=%{_localstatedir}	\
	--sharedstatedir=%{_sharedstatedir}	\
	--mandir=%{_mandir}			\
	--infodir=%{_infodir}			\
	--with-ucd-snmp-devel=ucdsnmp		\
	--with-group-id=90			\
	--with-ccmuser-id=90			\
	--enable-ltdl-convenience
  make

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  make DESTDIR=$RPM_BUILD_ROOT install
  (
    cd $RPM_BUILD_ROOT/etc/ha.d/resource.d
    ln -s /usr/sbin/ldirectord ldirectord
  )

  TEMPL=$RPM_BUILD_ROOT/var/adm/fillup-templates
  if
    [ ! -d $TEMPL ]
  then
    mkdir -p $TEMPL
  fi
  install -m 644 rc.config.heartbeat $TEMPL

%pre
if
  getent group haclient >/dev/null
then
  : OK group haclient already present
else
  GROUPOPT="-g 90"
  if
    /usr/sbin/groupadd $GROUPOPT haclient 2>/dev/null
  then
    : OK we were able to add group haclient
  else
    /usr/sbin/groupadd haclient
  fi
fi

if
  getent passwd hacluster >/dev/null
then
  : OK user hacluster already present
else
  USEROPT="-g haclient -u 511"
  if
    /usr/sbin/useradd $USEROPT hacluster 2>/dev/null
  then
    : OK we were able to add user hacluster
  else
    /usr/sbin/useradd hacluster
  fi
fi

%preun
  /sbin/chkconfig --del heartbeat

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Wed Mar 10 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.2.0, Release 1.5.4
  - Don't use %configure because the macro defined in our older version
    of rpm(8) and heartbeat don't jive, misnaming all the shared
    libraries.

* Mon Mar 01 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.2.0, Release 1.5.3
  - More hacks in %install, this time in /usr/lib.
  - Don't require 'telnet' in heartbeat-stonith.

* Mon Mar 01 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.2.0, Release 1.5.2
  - Fix autoconf mess with hack in %install.

* Mon Feb 23 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 1.2.0, Release 1.5.1
  - Initial build for EnGarde.
